CloseableThreadLocal (Lucene 2.4.1 API)
Keywords: org.apache.lucene.util.CloseableThreadLocal class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.util
Class CloseableThreadLocal

    java.lang.Object
      org.apache.lucene.util.CloseableThreadLocal

    public class CloseableThreadLocal

extends Object

Java's builtin ThreadLocal has a serious flaw: it can take an arbitrarily long amount of time to dereference the things you had stored in it, even once the ThreadLocal instance itself is no longer referenced. This is because there is single, master map stored for each thread, which all ThreadLocals share, and that master map only periodically purges "stale" entries. While not technically a memory leak, because eventually the memory will be reclaimed, it can take a long time and you can easily hit OutOfMemoryError because from the GC's standpoint the stale entries are not reclaimaible. This class works around that, by only enrolling WeakReference values into the ThreadLocal, and separately holding a hard reference to each stored value. When you call `close()`, these hard references are cleared and then GC is freely able to reclaim space by objects stored in it.

Constructor Summary
`CloseableThreadLocal()`

Method Summary
`void` | `close()`
`Object` | `get()`
`protected Object` | `initialValue()`
`void` | `set(Object object)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CloseableThreadLocal

    public CloseableThreadLocal()

Method Detail

### initialValue

    protected Object initialValue()

### get

    public Object get()

### set

    public void set(Object object)

### close

    public void close()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2009 Apache Software Foundation. All Rights Reserved.